## allegro5 5.2.2

=== CMakeLists.txt ===
#
#
# TODO:
#
# - some documentation targets still missing
# - installing documentation
#

#-----------------------------------------------------------------------------#
#
#   Build system setup
#
#-----------------------------------------------------------------------------#

# Set the project name.
# We use C++ in a few cases.
project(ALLEGRO C CXX)

cmake_minimum_required(VERSION 2.8.5 FATAL_ERROR)
if(COMMAND cmake_policy)
    cmake_policy(SET CMP0003 NEW)
    if(POLICY CMP0026)
        cmake_policy(SET CMP0026 OLD)
    endif()
endif(COMMAND cmake_policy)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel Profile."
      FORCE)
endif()
# Restrict configuration types to the selected build type.
# Note: This needs to be done before the project command
set(CMAKE_CONFIGURATION_TYPES "${CMAKE_BUILD_TYPE}" CACHE INTERNAL "internal")

if(ANDROID)
    option(WANT_ANDROID_LEGACY "Build for Android 4 (1.6)" OFF)
    set(ANDROID_TARGET "android-12" CACHE STRING "What Android target to compile for.")
endif(ANDROID)
option(WANT_GLES2 "Compile with GLES2 support" ON)
option(WANT_GLES3 "Compile with GLES3 support" OFF)
option(ALLEGRO_SDL "Build using the SDL backend (experimental)" OFF)
option(WANT_STATIC_RUNTIME "Whether or not to link the C and C++ runtimes statically (currently only implemented for MSVC)" OFF)

set(ALLEGRO_VERSION 5.2.2)
string(REGEX MATCH "^[0-9]+[.][0-9]+" ALLEGRO_SOVERSION ${ALLEGRO_VERSION})
string(REPLACE "." "" ALLEGRO_DLL_SHORTVER ${ALLEGRO_SOVERSION})

# Search in the `cmake' directory for additional CMake modules.
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

# Search in `deps' directories for dependency files.
file(GLOB deps_subdirs
    "${PROJECT_SOURCE_DIR}/deps"
    "${PROJECT_SOURCE_DIR}/deps/*"
    "${PROJECT_BINARY_DIR}/deps"
    "${PROJECT_BINARY_DIR}/deps/*"
    )
foreach(subdir ${deps_subdirs})
    if(EXISTS "${subdir}/include" OR EXISTS "${subdir}/lib")
        if(CMAKE_FIND_ROOT_PATH)
            message(STATUS "Adding ${subdir} to CMAKE_FIND_ROOT_PATH")
            list(APPEND CMAKE_FIND_ROOT_PATH "${subdir}")
        else()
            message(STATUS "Adding ${subdir} to CMAKE_PREFIX_PATH")
            list(APPEND CMAKE_PREFIX_PATH "${subdir}")
        endif()
    endif()
endforeach(subdir)

# Search for C header files in these directories.
include_directories(
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_BINARY_DIR}/include
    )

# Put libraries into `lib'.
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

# Lists of all the source files.
include(FileList)

# Our own CMake macros and functions.
include(Common)

#-----------------------------------------------------------------------------#
#
#   Build options
#
#-----------------------------------------------------------------------------#

if(NOT IPHONE)
    option(SHARED "Build shared libraries" on)
    set(BUILD_SHARED_LIBS ${SHARED})    # actual CMake variable
endif(NOT IPHONE)

# On some 64-bit platforms, libraries should be installed into `lib64'
# instead of `lib'.  Set this to 64 to do that.
set(LIB_SUFFIX "" CACHE STRING "Suffix for 'lib' directories, e.g. '64'")

option(WANT_FRAMEWORKS "Want frameworks on Mac OS X" off)
option(WANT_EMBED
    "Make frameworks embeddable in application bundles (Mac OS X)" on)

set(FRAMEWORK_INSTALL_PREFIX "/Library/Frameworks" CACHE STRING
    "Directory in which to install Mac OS X frameworks")

#
# Platforms and drivers.
#

option(WANT_X11 "X11 support" on)
option(WANT_X11_XF86VIDMODE "X11 XF86VidMode Extension support" on)
option(WANT_X11_XINERAMA "X11 Xinerama Extension support" on)
option(WANT_X11_XRANDR "X11 XRandR Extension support" on)
option(WANT_D3D "Enable Direct3D graphics driver (Windows)" on)
option(WANT_D3D9EX "Enable Direct3D 9Ex extensions (Vista)" off)
option(WANT_OPENGL "Enable OpenGL graphics driver (Windows, X11, OS X))" on)
option(WANT_SHADERS_GL "Build GLSL shader support (OpenGL)" on)
option(WANT_SHADERS_D3D "Build HLSL shader support (Direct3D)" on)
option(WANT_OPENGL_S3TC_LOCKING "Whether to support blocked locking of DXT1, DXT2, and DXT3 formats in OpenGL." off)

#
# Addons.
#

option(WANT_FONT "Enable bitmap font add-on" on)
option(WANT_AUDIO "Enable allegro_audio engine" on)
option(WANT_IMAGE "Enable image load/save addon" on)

if (NOT IPHONE)
    option(WANT_IMAGE_JPG "Enable JPEG support in image addon" on)
    option(WANT_IMAGE_PNG "Enable PNG support in image addon" on)
endif (NOT IPHONE)

option(WANT_TTF "Enable TTF addon" on)
option(WANT_COLOR "Enable color addon" on)
option(WANT_MEMFILE "Enable memfile addon" on)
option(WANT_PHYSFS "Enable PhysicsFS addon" on)
option(WANT_PRIMITIVES "Enable primitives addon" on)
option(WANT_NATIVE_DIALOG "Enable native dialog addon" on)
option(WANT_VIDEO "Enable video player addon" on)

option(WANT_MONOLITH "Include all addons in the main library" off)

#
# Wrappers.
#

option(WANT_PYTHON_WRAPPER "Enable generation of the Python wrapper" off)

#
# Documentation.
#

option(WANT_DOCS "Generate documentation" on)
option(WANT_DOCS_HTML "Generate HTML documentation" on)
option(WANT_DOCS_MAN "Generate man pages" on)
option(WANT_DOCS_INFO "Generate Info document" off)
option(WANT_DOCS_PDF "Generate PDF document (requires pdflatex)" off)
option(WANT_DOCS_PDF_PAPER "Whether PDF output is destined for paper" off)

#
# For developers.
#

option(STRICT_WARN "Halt at warnings" off)
option(WANT_MUDFLAP "Enable gcc mudflap (requires gcc 4.0+)" off)
option(WANT_RELEASE_LOGGING "Enable logging even in release mode" on)

if(WANT_RELEASE_LOGGING)
    set(ALLEGRO_CFG_RELEASE_LOGGING 1)
endif()

#
# Minor options.
#

if(NOT IPHONE)
    option(WANT_ALLOW_SSE "Allow compiler to use SSE instructions (x86)" on)
endif(NOT IPHONE)

option(NO_FPU "No floating point unit" off)
option(WANT_DLL_TLS "Force use of DllMain for TLS (Windows)" off)
option(WANT_DEMO "Build demo programs" on)
option(WANT_EXAMPLES "Build example programs" on)
option(WANT_POPUP_EXAMPLES "Use popups instead of printf for fatal errors" on)
option(WANT_TESTS "Build test programs" on)

#-----------------------------------------------------------------------------#
#
#   Set up compilers
#
#-----------------------------------------------------------------------------#

include(CheckCSourceCompiles)
include(CheckCXXSourceCompiles)

if(CMAKE_COMPILER_IS_GNUCC)
   get_gcc_system_include_dirs("c" "${CMAKE_C_COMPILER}" "${CMAKE_C_FLAGS}" SYSTEM_INCLUDE_DIRS)
   set(CMAKE_C_IMPLICIT_INCLUDE_DIRECTORIES ${CMAKE_C_IMPLICIT_INCLUDE_DIRECTORIES} ${SYSTEM_INCLUDE_DIRS})
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
   get_gcc_system_include_dirs("c++" "${CMAKE_CXX_COMPILER}" "${CMAKE_CXX_FLAGS}" SYSTEM_INCLUDE_DIRS)
   set(CMAKE_CXX_IMPLICIT_INCLUDE_DIRECTORIES ${CMAKE_CXX_IMPLICIT_INCLUDE_DIRECTORIES} ${SYSTEM_INCLUDE_DIRS})
endif()

if(CMAKE_COMPILER_IS_GNUCC)
    set(COMPILER_GCC 1)
    set(COMPILER_GCC_OR_CLANG 1)
endif()
if(CMAKE_C_COMPILER_ID MATCHES "Clang")
    set(COMPILER_GCC_OR_CLANG 1)
endif()

if(WIN32)
    if(WANT_DLL_TLS AND SHARED)
        set(ALLEGRO_CFG_DLL_TLS 1)
    endif(WANT_DLL_TLS AND SHARED)
endif(WIN32)

if(MSVC)
    set(COMPILER_MSVC 1)
    set(ALLEGRO_MSVC 1)

    # Guess VCINSTALLDIR from the value of CMAKE_C_COMPILER if it's not set.
    # XXX CMAKE_C_COMPILER will often be simply "cl" so this won't work.
    if("$ENV{VCINSTALLDIR}" STREQUAL "")
        string(REGEX REPLACE "/bin/[^/]*$" "" VCINSTALLDIR "${CMAKE_C_COMPILER}")
        message(STATUS "Guessed MSVC directory: ${VCINSTALLDIR}")
    else("$ENV{VCINSTALLDIR}" STREQUAL "")
        file(TO_CMAKE_PATH "$ENV{VCINSTALLDIR}" VCINSTALLDIR)
        message(STATUS "Using VCINSTALLDIR: ${VCINSTALLDIR}")
    endif("$ENV{VCINSTALLDIR}" STREQUAL "")

    # Install in VCINSTALLDIR by default
    if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
        set(CMAKE_INSTALL_PREFIX ${VCINSTALLDIR}
            CACHE PATH "Install path prefix, prepended onto install directories."
            FORCE)
    endif(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

    set(EXECUTABLE_TYPE "WIN32")
endif(MSVC)

if(MINGW)
    # For alplatf.h
    set(ALLEGRO_MINGW32 1)

    # Guess MINGDIR from the value of CMAKE_C_COMPILER if it's not set.
    if("$ENV{MINGDIR}" STREQUAL "")
        string(REGEX REPLACE "/bin/[^/]*$" "" MINGDIR "${CMAKE_C_COMPILER}")
        message(STATUS "Guessed MinGW directory: ${MINGDIR}")
    else("$ENV{MINGDIR}" STREQUAL "")
        file(TO_CMAKE_PATH "$ENV{MINGDIR}" MINGDIR)
        message(STATUS "Using MINGDIR: ${MINGDIR}")
    endif("$ENV{MINGDIR}" STREQUAL "")

    # Search in MINGDIR for headers and libraries.
    if(CMAKE_FIND_ROOT_PATH)
        list(APPEND CMAKE_FIND_ROOT_PATH "${MINGDIR}")
    else()
        list(APPEND CMAKE_PREFIX_PATH "${MINGDIR}")
    endif()

    # Install to MINGDIR
    if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
        set(CMAKE_INSTALL_PREFIX ${MINGDIR}
            CACHE PATH "Install path prefix, prepended onto install directories."
            FORCE)
    endif(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

    # Check for a common problem (at the time of writing).
    run_c_compile_test("
        #include <windows.h>
        int main(void)
        {
            int x = DM_POSITION;
            return 0;
        }"
        HAVE_DM_POSITION)
    if(NOT HAVE_DM_POSITION)
        message(FATAL_ERROR
            "Missing DM_POSITION. Please update your MinGW "
            "w32api package, delete CMakeCache.txt and try again.")
    endif(NOT HAVE_DM_POSITION)
endif(MINGW)

if(UNIX AND NOT APPLE AND NOT ANDROID)
    set(ALLEGRO_UNIX 1)
endif(UNIX AND NOT APPLE AND NOT ANDROID)

if(APPLE AND NOT IPHONE)
    set(MACOSX 1)
endif(APPLE AND NOT IPHONE)

if(MACOSX)
    set(ALLEGRO_MACOSX 1)
    set(ALLEGRO_CFG_PTHREADS_TLS 1)
    set(ALLEGRO_UNIX 0)
    set(WANT_X11 off)

    # This flag is required on some versions of Mac OS X to avoid linker
    # problems with global variables which are not explicitly initialised.
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-common")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-common")
endif(MACOSX)

if(IPHONE)
    set(ALLEGRO_CFG_PTHREADS_TLS 1)
    set(ALLEGRO_IPHONE 1)
    set(ALLEGRO_UNIX 0)
    set(WANT_X11 off)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
    set(CMAKE_EXE_LINKER_FLAGS "-framework CoreGraphics -framework QuartzCore -framework UIKit -framework Foundation -framework CoreFoundation -framework MobileCoreServices")
endif(IPHONE)

if(BORLAND)
    set(ALLEGRO_BCC32 1)
endif(BORLAND)

if(ANDROID)
   set(ALLEGRO_ANDROID 1)
   set(ALLEGRO_CFG_PTHREADS_TLS 1)
   set(WANT_X11 off)
endif(ANDROID)

if(ALLEGRO_RASPBERRYPI)
    set(ALLEGRO_CFG_PTHREADS_TLS 1)
endif(ALLEGRO_RASPBERRYPI)

if(ALLEGRO_SDL)
   set(ALLEGRO_UNIX 0)
   set(WANT_X11 off)
   include(FindSDL2)
endif(ALLEGRO_SDL)

# Tell the compiler it can use SSE instructions on x86 architectures.
# If compatibility with Pentium 2's and below is required then the user
# should switch WANT_ALLOW_SSE off.

# Workaround for a possible bug in CMake.  Even if we set this variable in
# the toolchain file when cross-compiling, as we should, it is empty.
if(NOT CMAKE_SYSTEM_PROCESSOR AND CMAKE_SYSTEM_NAME STREQUAL Windows)
    set(CMAKE_SYSTEM_PROCESSOR i686)
endif()

if(CMAKE_SYSTEM_PROCESSOR MATCHES "i.86")
    set(ARCH_X86 1)
endif()
# CMake reports "x86" on my Windows Vista machine
if(CMAKE_SYSTEM_PROCESSOR MATCHES "x86")
    set(ARCH_X86 1)
endif()

if(ARCH_X86 AND WANT_ALLOW_SSE)
    if(COMPILER_GCC_OR_CLANG)
        message(STATUS "Allowing GCC/Clang to use SSE instructions")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -msse")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse")
    endif(COMPILER_GCC_OR_CLANG)

    # Flags for other compilers should be added here.

    if(COMPILER_MSVC)
        message(STATUS "Allowing MSVC to use SSE instructions")

=== addons/CMakeLists.txt ===
# FOO_LINK_WITH and SUPPORT_FOO need to be propagated up to the parent scope so
# examples know if they can use the FOO addon, and what to link against.
# FOO_LINK_WITH should be the name of a single target.  The target should
# automatically pull in dependencies so they don't need to be listed.

include(FindPackageHandleStandardArgs)

set(ADDON_PKG_CONFIG_FILES)

if(WANT_PRIMITIVES)
    add_subdirectory(primitives)
    set(SUPPORT_PRIMITIVES 1)
    set(SUPPORT_PRIMITIVES 1 PARENT_SCOPE)
    set(PRIMITIVES_LINK_WITH ${PRIMITIVES_LINK_WITH} PARENT_SCOPE)
    list(APPEND ADDON_PKG_CONFIG_FILES allegro_primitives)
endif(WANT_PRIMITIVES)

if(WANT_IMAGE)
    add_subdirectory(image)
    set(SUPPORT_IMAGE 1)
    set(SUPPORT_IMAGE 1 PARENT_SCOPE)
    set(IMAGE_LINK_WITH ${IMAGE_LINK_WITH} PARENT_SCOPE)
    list(APPEND ADDON_PKG_CONFIG_FILES allegro_image)
endif(WANT_IMAGE)

if(WANT_FONT AND SUPPORT_IMAGE)
    add_subdirectory(font)
    set(SUPPORT_FONT 1)
    set(SUPPORT_FONT 1 PARENT_SCOPE)
    set(FONT_LINK_WITH ${FONT_LINK_WITH} PARENT_SCOPE)
    list(APPEND ADDON_PKG_CONFIG_FILES allegro_font)
endif(WANT_FONT AND SUPPORT_IMAGE)

if(WANT_AUDIO)
    add_subdirectory(audio)
    if(SUPPORT_AUDIO)
        set(SUPPORT_AUDIO 1 PARENT_SCOPE)
        set(AUDIO_LINK_WITH ${AUDIO_LINK_WITH} PARENT_SCOPE)
        list(APPEND ADDON_PKG_CONFIG_FILES allegro_audio)
    endif(SUPPORT_AUDIO)
endif(WANT_AUDIO)

if(SUPPORT_AUDIO)
    add_subdirectory(acodec)
    if(SUPPORT_ACODEC)
        set(SUPPORT_ACODEC 1 PARENT_SCOPE)
        set(ACODEC_LINK_WITH ${ACODEC_LINK_WITH} PARENT_SCOPE)
        list(APPEND ADDON_PKG_CONFIG_FILES allegro_acodec)
    endif(SUPPORT_ACODEC)
endif(SUPPORT_AUDIO)

if(SUPPORT_FONT AND WANT_TTF)
    find_package(Freetype)
    if(FREETYPE_FOUND)
        add_subdirectory(ttf)
        set(SUPPORT_TTF 1 PARENT_SCOPE)
        set(TTF_LINK_WITH ${TTF_LINK_WITH} PARENT_SCOPE)
        list(APPEND ADDON_PKG_CONFIG_FILES allegro_ttf)
    else(FREETYPE_FOUND)
        message("WARNING: FreeType not found, disabling support.")
    endif(FREETYPE_FOUND)
endif(SUPPORT_FONT AND WANT_TTF)

if(WANT_COLOR)
    add_subdirectory(color)
    set(SUPPORT_COLOR 1 PARENT_SCOPE)
    set(COLOR_LINK_WITH ${COLOR_LINK_WITH} PARENT_SCOPE)
    list(APPEND ADDON_PKG_CONFIG_FILES allegro_color)
endif(WANT_COLOR)

if(WANT_MEMFILE)
    add_subdirectory(memfile)
    set(SUPPORT_MEMFILE 1 PARENT_SCOPE)
    set(MEMFILE_LINK_WITH ${MEMFILE_LINK_WITH} PARENT_SCOPE)
    list(APPEND ADDON_PKG_CONFIG_FILES allegro_memfile)
endif(WANT_MEMFILE)

if(WANT_PHYSFS)
    find_package(PhysFS)
    # FindPhysFS.cmake in cmake-2.6.2 doesn't call this but it should.
    find_package_handle_standard_args(PHYSFS DEFAULT_MSG
        PHYSFS_LIBRARY PHYSFS_INCLUDE_DIR)
    mark_as_advanced(PHYSFS_INCLUDE_DIR)
    mark_as_advanced(PHYSFS_LIBRARY)

    find_package(ZLIB)

    # Does this copy of PhysicsFS require zlib to be linked separately?
    # FindPhysFS should really figure this out for us, but it doesn't.
    if(PHYSFS_FOUND)
        set(CMAKE_REQUIRED_INCLUDES ${PHYSFS_INCLUDE_DIR})
        set(CMAKE_REQUIRED_LIBRARIES ${PHYSFS_LIBRARY})
        run_c_compile_test("
            #include <physfs.h>

            int main(int argc, char **argv)
            {
                (void)argc;
                PHYSFS_init(argv[0]);
                PHYSFS_deinit();
                return 0;
            }"
            PHYSFS_IMPLICIT_ZLIB)
        set(CMAKE_REQUIRED_INCLUDES)
        set(CMAKE_REQUIRED_LIBRARIES)

        if(PHYSFS_IMPLICIT_ZLIB)
            set(PHYSFS_LIBRARIES ${PHYSFS_LIBRARY})
            set(SUPPORT_PHYSFS 1)
        elseif(ZLIB_FOUND)
            set(PHYSFS_LIBRARIES ${PHYSFS_LIBRARY} ${ZLIB_LIBRARY})
            set(SUPPORT_PHYSFS 1)
        else()
            message("WARNING: PhysicsFS needs zlib, zlib not found, disabling PhysFS support.")
        endif()
    endif(PHYSFS_FOUND)

    if(SUPPORT_PHYSFS)
        add_subdirectory(physfs)
        set(SUPPORT_PHYSFS 1 PARENT_SCOPE)
        set(PHYSFS_LINK_WITH ${PHYSFS_LINK_WITH} PARENT_SCOPE)
        list(APPEND ADDON_PKG_CONFIG_FILES allegro_physfs)
    endif(SUPPORT_PHYSFS)
endif(WANT_PHYSFS)

if(WANT_NATIVE_DIALOG)
    add_subdirectory(native_dialog)
    if(SUPPORT_NATIVE_DIALOG)
        set(SUPPORT_NATIVE_DIALOG 1 PARENT_SCOPE)
        set(NATIVE_DIALOG_LINK_WITH ${NATIVE_DIALOG_LINK_WITH} PARENT_SCOPE)
        list(APPEND ADDON_PKG_CONFIG_FILES allegro_dialog)
    endif()
endif(WANT_NATIVE_DIALOG)

if(WANT_VIDEO)
    add_subdirectory(video)
    if(SUPPORT_VIDEO)
        set(SUPPORT_VIDEO 1 PARENT_SCOPE)
        set(VIDEO_LINK_WITH ${VIDEO_LINK_WITH} PARENT_SCOPE)
        list(APPEND ADDON_PKG_CONFIG_FILES allegro_video)
    endif(SUPPORT_VIDEO)
endif(WANT_VIDEO)

add_subdirectory(main)
# SUPPORT_MAIN and MAIN_LINK_WITH are spelt as such in this scope,
# but are prefixed with ALLEGRO in the parent scope.
set(SUPPORT_ALLEGRO_MAIN ${SUPPORT_MAIN} PARENT_SCOPE)
set(ALLEGRO_MAIN_LINK_WITH ${MAIN_LINK_WITH} PARENT_SCOPE)
list(APPEND ADDON_PKG_CONFIG_FILES allegro_main)

set(MONOLITH_SOURCES ${MONOLITH_SOURCES} PARENT_SCOPE)
set(MONOLITH_INCLUDE_DIRECTORIES ${MONOLITH_INCLUDE_DIRECTORIES} PARENT_SCOPE)
set(MONOLITH_LINK_DIRECTORIES ${MONOLITH_LINK_DIRECTORIES} PARENT_SCOPE)
set(MONOLITH_LIBRARIES ${MONOLITH_LIBRARIES} PARENT_SCOPE)
set(MONOLITH_HEADERS ${MONOLITH_HEADERS} PARENT_SCOPE)
set(MONOLITH_DEFINES ${MONOLITH_DEFINES} PARENT_SCOPE)

set(ADDON_PKG_CONFIG_FILES ${ADDON_PKG_CONFIG_FILES} PARENT_SCOPE)

#-----------------------------------------------------------------------------#
# vi: set ts=8 sts=4 sw=4 et:

=== android/CMakeLists.txt ===
# The android tool on Windows is a batch file wrapper, which cannot be
# started by MSYS shell directly. We invoke it via cmd.exe instead.
# We don't use the full path to avoid problems with spaces,
# and hope that android.bat is somewhere on the PATH.
if(ANDROID_TOOL MATCHES "[.]bat$")
    set(ANDROID_UPDATE_COMMAND
        cmd.exe /c "android.bat update project -p . -t ${ANDROID_TARGET}")
else()
    set(ANDROID_UPDATE_COMMAND
        "${ANDROID_TOOL}" update project -p . -t ${ANDROID_TARGET})
endif()

include(Activity.cmake)

if(WANT_EXAMPLES)
    include(Example.cmake)
endif()

#-----------------------------------------------------------------------------#
# vim: set sts=4 sw=4 et:

=== tests/CMakeLists.txt ===
if(NOT ALLEGRO_LINK_WITH OR NOT ALLEGRO_MAIN_LINK_WITH OR
        NOT IMAGE_LINK_WITH OR NOT COLOR_LINK_WITH OR
        NOT FONT_LINK_WITH OR NOT TTF_LINK_WITH OR
        NOT PRIMITIVES_LINK_WITH)
    message(STATUS "Not building tests due to missing library. "
        "Have: ${ALLEGRO_LINK_WITH} ${ALLEGRO_MAIN_LINK_WITH} "
        "${IMAGE_LINK_WITH} ${COLOR_LINK_WITH} "
        "${FONT_LINK_WITH} ${TTF_LINK_WITH} "
        "${PRIMITIVES_LINK_WITH}")
    return()
endif()

include_directories(
    ../addons/acodec
    ../addons/audio
    ../addons/color
    ../addons/font
    ../addons/image
    ../addons/main
    ../addons/memfile
    ../addons/native_dialog
    ../addons/physfs
    ../addons/primitives
    ../addons/shader
    ../addons/ttf
    )

if(MSVC)
    set(EXECUTABLE_TYPE)
endif(MSVC)

if(WANT_MONOLITH)
   add_our_executable(
       test_driver
       LIBS
       ${ALLEGRO_MONOLITH_LINK_WITH}
       )
else(WANT_MONOLITH)
   add_our_executable(
       test_driver
       LIBS
       ${ALLEGRO_LINK_WITH}
       ${ALLEGRO_MAIN_LINK_WITH}
       ${IMAGE_LINK_WITH}
       ${COLOR_LINK_WITH}
       ${FONT_LINK_WITH}
       ${TTF_LINK_WITH}
       ${PRIMITIVES_LINK_WITH}
       ${SHADER_LINK_WITH}
       )
endif(WANT_MONOLITH)

set(test_files
    ${CMAKE_CURRENT_SOURCE_DIR}/test_bitmaps.ini
    ${CMAKE_CURRENT_SOURCE_DIR}/test_bitmaps2.ini
    ${CMAKE_CURRENT_SOURCE_DIR}/test_blend.ini
    ${CMAKE_CURRENT_SOURCE_DIR}/test_locking.ini
    ${CMAKE_CURRENT_SOURCE_DIR}/test_locking2.ini
    ${CMAKE_CURRENT_SOURCE_DIR}/test_backbuffer.ini
    ${CMAKE_CURRENT_SOURCE_DIR}/test_image.ini
    ${CMAKE_CURRENT_SOURCE_DIR}/test_fonts.ini
    ${CMAKE_CURRENT_SOURCE_DIR}/test_prim.ini
    ${CMAKE_CURRENT_SOURCE_DIR}/test_prim2.ini
    ${CMAKE_CURRENT_SOURCE_DIR}/test_convert.ini
    )

add_dependencies(test_driver copy_example_data)

add_custom_target(run_tests
    DEPENDS test_driver
    COMMAND test_driver ${test_files}
    )

add_custom_target(run_tests_gl
    DEPENDS test_driver
    COMMAND test_driver --force-opengl ${test_files}
    )

add_custom_target(run_tests_gl12
    DEPENDS test_driver
    COMMAND test_driver --force-opengl-1.2 ${test_files}
    )

add_custom_target(run_tests_gl20
    DEPENDS test_driver
    COMMAND test_driver --force-opengl-2.0 ${test_files}
    )

add_custom_target(run_tests_d3d
    DEPENDS test_driver
    COMMAND test_driver --force-d3d ${test_files}
    )

add_custom_target(run_tests_wine
    DEPENDS test_driver
    COMMAND wine test_driver ${test_files}
    )

add_custom_target(run_tests_wine_gl
    DEPENDS test_driver
    COMMAND wine test_driver --force-opengl ${test_files}
    )

add_custom_target(run_tests_shaders
    DEPENDS test_driver
    COMMAND test_driver --use-shaders ${test_files}
    )

# vim: set sts=4 sw=4 et:

=== addons/acodec/CMakeLists.txt ===
include_directories(../audio)

option(WANT_FLAC "Enable FLAC support" on)
if(WIN32)
    option(FLAC_STATIC "Set this if linking with a static FLAC library" off)
endif()
option(WANT_VORBIS "Enable Ogg Vorbis support using libvorbis" on)
option(WANT_TREMOR "Enable Ogg Vorbis support using Tremor" off)
option(WANT_OPUS "Enable Opus support using libopus" on)
option(WANT_MODAUDIO "Enable MOD Audio support" on)
option(WANT_ACODEC_DYNAMIC_LOAD "Enable DLL loading in acodec (Windows)" off)

#-----------------------------------------------------------------------------#

set(ACODEC_INCLUDE_FILES
    allegro5/allegro_acodec.h
    )

set_our_header_properties(${ACODEC_INCLUDE_FILES})

set(ACODEC_SOURCES
    acodec.c
    wav.c
    helper.c
    voc.c        # built-in enhanced port of A4 loader
    )
set(ACODEC_LIBRARIES)

# For dynamic loading, we want to make sure that CMake has found an import
# library and not a static library. We assume that the name of the DLL to load
# is the same as the import library, bar the extension.
#
# With MSVC, static libraries and import libraries share the same extension.
# Luckily the MSVC static libraries for FLAC and Vorbis are named with a
# _static suffix.
# With MinGW, static libraries end with .a, and import libraries end with
# .dll.a so we can tell them apart. (The regex for this is a bodge.)
set(WIN32_STATIC_LIB_REGEX "_static[.]|[^l][.]a")

function(get_dll_name implib dllname_var)
    if(MINGW)
        # Guess the name of dlltool from gcc.
        string(REGEX REPLACE "gcc.*" dlltool DLLTOOL ${CMAKE_C_COMPILER})
        execute_process(
            COMMAND ${DLLTOOL} -I ${implib}
            OUTPUT_VARIABLE dllname
            OUTPUT_STRIP_TRAILING_WHITESPACE
            )
    elseif(MSVC)
        # Not sure this is the best way.
        execute_process(
            COMMAND lib /LIST ${implib}
            OUTPUT_VARIABLE output
            )
        if(output STREQUAL "")
            message("WARNING: Failed to execute lib /list")
        else()
            string(REGEX MATCH "[^\n]+[.]dll" dllname "${output}")
        endif()
    endif()
    if(NOT dllname)
        # Guess from the basename.
        get_filename_component(basename "${implib}" NAME_WE)
        set(dllname "${basename}.dll")
    endif()
    message(STATUS "DLL name for ${implib}: ${dllname}")
    set(${dllname_var} ${dllname} PARENT_SCOPE)
endfunction(get_dll_name)

#
# FLAC
#

if(WANT_FLAC)
    find_package(FLAC)
    if(FLAC_FOUND)
        if(FLAC_LIBRARY MATCHES "${WIN32_STATIC_LIB_REGEX}")
            set(FLAC_STATIC 1)
        endif()
        if(FLAC_STATIC)
            set(FLAC__NO_DLL "-DFLAC__NO_DLL")
        endif()
        set(CMAKE_REQUIRED_INCLUDES ${FLAC_INCLUDE_DIR})
        if(MSVC)
            set(CMAKE_REQUIRED_LIBRARIES ${FLAC_LIBRARIES})
        else()
            # FLAC requires libm on Android, doesn't seem to hurt elsewhere either.
            set(CMAKE_REQUIRED_LIBRARIES ${FLAC_LIBRARIES} m)
        endif()
        set(CMAKE_REQUIRED_DEFINITIONS ${FLAC__NO_DLL})
        run_c_compile_test("
            #include <FLAC/stream_decoder.h>
            int main(void)
            {
                (void)FLAC__stream_decoder_new();
                return 0;
            }"
            FLAC_COMPILES)
        set(CMAKE_REQUIRED_INCLUDES)
        set(CMAKE_REQUIRED_LIBRARIES)
        set(CMAKE_REQUIRED_DEFINITIONS)
        if(FLAC_COMPILES)
            set(SUPPORT_FLAC 1)
        endif(FLAC_COMPILES)
    endif(FLAC_FOUND)
    if(NOT SUPPORT_FLAC)
        message("WARNING: libFLAC not found or compile test failed, disabling support.")
    endif(NOT SUPPORT_FLAC)
endif(WANT_FLAC)

if(SUPPORT_FLAC)
    include_directories(SYSTEM ${FLAC_INCLUDE_DIR})
    set(ALLEGRO_CFG_ACODEC_FLAC 1)
    list(APPEND ACODEC_SOURCES flac.c)

    list(APPEND ACODEC_INCLUDE_DIRECTORIES ${FLAC_INCLUDE_DIR})

    if(WIN32)
        if(WANT_ACODEC_DYNAMIC_LOAD)
            if(FLAC_STATIC)
                message("WARNING: Dynamic loading will be disabled for FLAC as"
                        " static library was found: ${FLAC_LIBRARY}")
            else()
                get_dll_name(${FLAC_LIBRARY} ALLEGRO_CFG_ACODEC_FLAC_DLL)
            endif()
        endif()
    endif(WIN32)

    if(NOT ALLEGRO_CFG_ACODEC_FLAC_DLL)
        list(APPEND ACODEC_LIBRARIES ${FLAC_LIBRARIES})
    endif()
endif(SUPPORT_FLAC)

#
# MOD audio
#

if(WANT_MODAUDIO)
    find_package(DUMB)
    if(DUMB_FOUND)
        set(CMAKE_REQUIRED_INCLUDES ${DUMB_INCLUDE_DIR})
        set(CMAKE_REQUIRED_LIBRARIES ${DUMB_LIBRARIES})
        run_c_compile_test("
            #include <dumb.h>
            int main(void)
            {
                dumb_register_stdfiles();
                return 0;
            }"
            DUMB_COMPILES)
        set(CMAKE_REQUIRED_INCLUDES)
        set(CMAKE_REQUIRED_LIBRARIES)
        if(DUMB_COMPILES)
            set(SUPPORT_MODAUDIO 1)
        endif(DUMB_COMPILES)
    endif(DUMB_FOUND)
    if(NOT SUPPORT_MODAUDIO)
        message("WARNING: libdumb not found or compile test failed, "
                "disabling support. <http://dumb.sourceforge.net/>")
    endif(NOT SUPPORT_MODAUDIO)
endif(WANT_MODAUDIO)

if(SUPPORT_MODAUDIO)
    include_directories(SYSTEM ${DUMB_INCLUDE_DIR})
    set(ALLEGRO_CFG_ACODEC_MODAUDIO 1)
    list(APPEND ACODEC_SOURCES modaudio.c)

    list(APPEND ACODEC_INCLUDE_DIRECTORIES ${DUMB_INCLUDE_DIR})

    if(WIN32 AND WANT_ACODEC_DYNAMIC_LOAD)
        if(DUMB_LIBRARY MATCHES "${WIN32_STATIC_LIB_REGEX}")
            message("WARNING: Dynamic loading will be disabled for DUMB"
                    " as static library was found: ${DUMB_LIBRARY}")
        else()
            get_dll_name(${DUMB_LIBRARY} ALLEGRO_CFG_ACODEC_DUMB_DLL)
        endif()
    endif()

    if(NOT ALLEGRO_CFG_ACODEC_DUMB_DLL)
        list(APPEND ACODEC_LIBRARIES ${DUMB_LIBRARIES})
    endif()
endif()

#
# Vorbis/Tremor
#

if(WANT_TREMOR)
    find_package(Tremor)
    if(TREMOR_FOUND)
        set(CMAKE_REQUIRED_INCLUDES ${TREMOR_INCLUDE_DIR})
        set(CMAKE_REQUIRED_LIBRARIES ${TREMOR_LIBRARIES})
        run_c_compile_test("
            #include <tremor/ivorbisfile.h>
            int main(void)
            {
                OggVorbis_File f;
                ov_info(&f, -1);
                return 0;
            }"
            TREMOR_COMPILES)
        set(CMAKE_REQUIRED_INCLUDES)
        set(CMAKE_REQUIRED_LIBRARIES)
        if(TREMOR_COMPILES OR IPHONE OR ALLEGRO_RASPBERRYPI)
            set(SUPPORT_VORBIS 1)
        endif(TREMOR_COMPILES OR IPHONE OR ALLEGRO_RASPBERRYPI)
    endif(TREMOR_FOUND)
    if(NOT SUPPORT_VORBIS)
        message("WARNING: Tremor not found although WANT_TREMOR was specified.")
    else(NOT SUPPORT_VORBIS)
        # mimic regular libogg/libvorbis
        set(OGG_INCLUDE_DIR ${TREMOR_INCLUDE_DIR})
        set(VORBIS_INCLUDE_DIR ${TREMOR_INCLUDE_DIR})
        set(VORBIS_LIBRARIES ${TREMOR_LIBRARIES})
        set(ALLEGRO_CFG_ACODEC_TREMOR 1)
    endif(NOT SUPPORT_VORBIS)
elseif(WANT_VORBIS)
    find_package(Vorbis)
    if(VORBIS_FOUND)
        set(CMAKE_REQUIRED_INCLUDES ${OGG_INCLUDE_DIR} ${VORBIS_INCLUDE_DIR})
        if(COMPILER_GCC_OR_CLANG)
            # libm is required when linking statically.
            set(CMAKE_REQUIRED_LIBRARIES "${VORBIS_LIBRARIES};m")
        else()
            set(CMAKE_REQUIRED_LIBRARIES "${VORBIS_LIBRARIES}")
        endif(COMPILER_GCC_OR_CLANG)
        run_c_compile_test("
            #include <vorbis/vorbisfile.h>
            int main(void)
            {
                OggVorbis_File f;
                ov_callbacks callback;
                vorbis_info *v = 0;
                (void)v;
                ov_info(&f, -1);
                callback = OV_CALLBACKS_NOCLOSE;
                return 0;
            }"
            VORBIS_COMPILES)
        set(CMAKE_REQUIRED_INCLUDES)
        set(CMAKE_REQUIRED_LIBRARIES)
        if(VORBIS_COMPILES)
            set(SUPPORT_VORBIS 1)
        endif()
    endif(VORBIS_FOUND)
    if(NOT SUPPORT_VORBIS)
        message("WARNING: libvorbis not found or compile test failed, disabling support.")
    endif(NOT SUPPORT_VORBIS)
endif()

if(SUPPORT_VORBIS)
    include_directories(SYSTEM ${OGG_INCLUDE_DIR} ${VORBIS_INCLUDE_DIR})
    set(ALLEGRO_CFG_ACODEC_VORBIS 1)
    list(APPEND ACODEC_SOURCES ogg.c)

    list(APPEND ACODEC_INCLUDE_DIRECTORIES ${OGG_INCLUDE_DIR} ${VORBIS_INCLUDE_DIR})

    if(WIN32 AND WANT_ACODEC_DYNAMIC_LOAD AND NOT WANT_TREMOR)
        if(VORBISFILE_LIBRARY MATCHES "${WIN32_STATIC_LIB_REGEX}")
            message("WARNING: Dynamic loading will be disabled for Vorbis"
                    " as static library was found: ${VORBISFILE_LIBRARY}")
        else()
            get_dll_name(${VORBISFILE_LIBRARY} ALLEGRO_CFG_ACODEC_VORBISFILE_DLL)
        endif()
    endif()

    if(NOT ALLEGRO_CFG_ACODEC_VORBISFILE_DLL)
        list(APPEND ACODEC_LIBRARIES ${VORBIS_LIBRARIES})
    endif()
endif(SUPPORT_VORBIS)

#
# Opus
#

if(WANT_OPUS)
    find_package(Opus)
    if(OPUS_FOUND)
        set(CMAKE_REQUIRED_INCLUDES ${OGG_INCLUDE_DIR} ${OPUS_INCLUDE_DIR})
        if(COMPILER_GCC_OR_CLANG)
            # libm is required when linking statically.
            set(CMAKE_REQUIRED_LIBRARIES "${OPUS_LIBRARIES};m")
        else()
            set(CMAKE_REQUIRED_LIBRARIES "${OPUS_LIBRARIES}")
        endif(COMPILER_GCC_OR_CLANG)
        run_c_compile_test("
            #include <opus/opusfile.h>
            int main(void)
            {
                OggOpusFile *f;
                OpusHead *v = 0;
                (void)v;
                op_free(f);
                return 0;
            }"
            OPUS_COMPILES)
        set(CMAKE_REQUIRED_INCLUDES)
        set(CMAKE_REQUIRED_LIBRARIES)
        if(OPUS_COMPILES)
            set(SUPPORT_OPUS 1)
        endif()
    endif(OPUS_FOUND)
    if(NOT SUPPORT_OPUS)
        message("WARNING: libopus not found or compile test failed, disabling support.")
    endif(NOT SUPPORT_OPUS)
endif()

if(SUPPORT_OPUS)
    include_directories(SYSTEM ${OGG_INCLUDE_DIR} ${OPUS_INCLUDE_DIR})
    set(ALLEGRO_CFG_ACODEC_OPUS 1)
    list(APPEND ACODEC_SOURCES opus.c)

    list(APPEND ACODEC_INCLUDE_DIRECTORIES ${OGG_INCLUDE_DIR} ${OPUS_INCLUDE_DIR})

    if(WIN32 AND WANT_ACODEC_DYNAMIC_LOAD)
        if(OPUSFILE_LIBRARY MATCHES "${WIN32_STATIC_LIB_REGEX}")
            message("WARNING: Dynamic loading will be disabled for Opus"
                    " as static library was found: ${OPUSFILE_LIBRARY}")
        else()
            get_dll_name(${OPUSFILE_LIBRARY} ALLEGRO_CFG_ACODEC_OPUSFILE_DLL)
        endif()
    endif()

    if(NOT ALLEGRO_CFG_ACODEC_OPUSFILE_DLL)
        list(APPEND ACODEC_LIBRARIES ${OPUS_LIBRARIES})
    endif()
endif(SUPPORT_OPUS)

configure_file(
    allegro5/internal/aintern_acodec_cfg.h.cmake
    ${PROJECT_BINARY_DIR}/include/allegro5/internal/aintern_acodec_cfg.h
    )

add_our_addon_library(allegro_acodec
    AllegroAcodec-${ALLEGRO_SOVERSION}
    "${ACODEC_SOURCES};${ACODEC_INCLUDE_FILES}"
    "-DALLEGRO_ACODEC_SRC ${FLAC__NO_DLL}"
    "${AUDIO_LINK_WITH};${ACODEC_LIBRARIES}"
    )

install_our_headers(${ACODEC_INCLUDE_FILES})

add_addon(acodec)


#-----------------------------------------------------------------------------#
# vim: set ts=8 sts=4 sw=4 et:

=== addons/image/CMakeLists.txt ===
option(WANT_NATIVE_IMAGE_LOADER "Enable the native platform image loader (if available)" on)

set(IMAGE_SOURCES bmp.c iio.c pcx.c tga.c dds.c identify.c)
set(IMAGE_INCLUDE_FILES allegro5/allegro_image.h)

set_our_header_properties(${IMAGE_INCLUDE_FILES})

# Accumulate these.
set(IMAGE_LIBRARIES)
set(IMAGE_DEFINES)

# ALLEGRO_CFG_IIO_HAVE_* are the available libraries.
# ALLEGRO_CFG_IIO_SUPPORT_* are the supported formats.

# First look for native libraries and mark any supported image
# type as found, so that the associated third party libraries 
# don't need to be used.

if(WANT_NATIVE_IMAGE_LOADER)
    set(ALLEGRO_CFG_WANT_NATIVE_IMAGE_LOADER 1)

    if(WIN32)
        find_package(GDIPLUS)
        if(GDIPLUS_FOUND)
            set(CMAKE_REQUIRED_DEFINITIONS -DGDIPLUS_LOWERCASE=${GDIPLUS_LOWERCASE})
            set(CMAKE_REQUIRED_INCLUDES ${GDIPLUS_INCLUDE_DIR})
            set(CMAKE_REQUIRED_LIBRARIES ${GDIPLUS_LIBRARY})
            run_cxx_compile_test("
                #include <windows.h>
                #include <objidl.h>
                #if GDIPLUS_LOWERCASE
                    #include <gdiplus.h>
                #else
                    #include <GdiPlus.h>
                #endif
                using namespace Gdiplus;
                int main(void)
                {
                    int pf = PixelFormat32bppARGB;
                    return 0;
                }
                "
                SUPPORT_GDIPLUS)
        endif(GDIPLUS_FOUND)
        if(SUPPORT_GDIPLUS)
            set(ALLEGRO_CFG_IIO_HAVE_GDIPLUS 1)
            set(ALLEGRO_CFG_IIO_HAVE_GDIPLUS_LOWERCASE_H ${GDIPLUS_LOWERCASE})
            set(ALLEGRO_CFG_IIO_SUPPORT_PNG 1)
            set(ALLEGRO_CFG_IIO_SUPPORT_JPG 1)
            list(APPEND IMAGE_SOURCES gdiplus.cpp)
            list(APPEND IMAGE_LIBRARIES ${GDIPLUS_LIBRARIES})
            if(MINGW)
                list(APPEND IMAGE_LIBRARIES uuid)
            endif(MINGW)
            list(APPEND IMAGE_DEFINES ${GDIPLUS_DEFINITIONS})
            list(APPEND IMAGE_INCLUDE_DIRECTORIES ${GDIPLUS_INCLUDE_DIR})
            include_directories(SYSTEM ${GDIPLUS_INCLUDE_DIR})            
        else(SUPPORT_GDIPLUS)
            message("WARNING: cannot use GDI+. Will try other libraries.")
        endif(SUPPORT_GDIPLUS)
    endif(WIN32)

    if (MACOSX)
        set(ALLEGRO_CFG_IIO_SUPPORT_PNG 1)
        set(ALLEGRO_CFG_IIO_SUPPORT_JPG 1)
        list(APPEND IMAGE_SOURCES macosx.m)
    endif(MACOSX)

    if(ANDROID)
        set(ALLEGRO_CFG_IIO_HAVE_ANDROID 1)
        set(ALLEGRO_CFG_IIO_SUPPORT_JPG 1)
        set(ALLEGRO_CFG_IIO_SUPPORT_PNG 1)
        list(APPEND IMAGE_SOURCES android.c)
    endif(ANDROID)

    if(IPHONE)
        list(APPEND IMAGE_SOURCES iphone.m)
    endif(IPHONE)
endif(WANT_NATIVE_IMAGE_LOADER)

# Now look for third party libraries to handle the unsupported formats

if(WANT_IMAGE_PNG AND NOT ALLEGRO_CFG_IIO_SUPPORT_PNG)
    find_package(PNG)
    if(PNG_FOUND)
        # HAVE_PNG means libpng is available (and should be used)
        set(ALLEGRO_CFG_IIO_HAVE_PNG 1)
        set(ALLEGRO_CFG_IIO_SUPPORT_PNG 1)
        list(APPEND IMAGE_SOURCES png.c)
        list(APPEND IMAGE_LIBRARIES ${PNG_LIBRARIES})
        list(APPEND IMAGE_DEFINES ${PNG_DEFINITIONS})
        list(APPEND IMAGE_INCLUDE_DIRECTORIES ${PNG_INCLUDE_DIR})
        include_directories(SYSTEM ${PNG_INCLUDE_DIR})
    else(PNG_FOUND)
        message("WARNING: libpng not found, disabling support")
    endif(PNG_FOUND)
endif(WANT_IMAGE_PNG AND NOT ALLEGRO_CFG_IIO_SUPPORT_PNG)

if(WANT_IMAGE_JPG AND NOT ALLEGRO_CFG_IIO_SUPPORT_JPG)
    find_package(JPEG)
    if(JPEG_FOUND AND MINGW)
        set(CMAKE_REQUIRED_INCLUDES ${JPEG_INCLUDE_DIR})
        run_c_compile_test("
            #include <stdio.h>
            #include <windows.h>
            #include <jpeglib.h>
            #include <jerror.h>
            int main(void) {
                return 0;
            }"
            JPEG_COMPILES)
        set(CMAKE_REQUIRED_INCLUDES)
        set(SUPPORT_JPEG ${JPEG_COMPILES})
    else()
        set(SUPPORT_JPEG ${JPEG_FOUND})
    endif()
    if(SUPPORT_JPEG)
        # HAVE_JPG means libjpeg is available (and should be used)
        set(ALLEGRO_CFG_IIO_HAVE_JPG 1)
        set(ALLEGRO_CFG_IIO_SUPPORT_JPG 1)
        list(APPEND IMAGE_SOURCES jpg.c)
        list(APPEND IMAGE_LIBRARIES ${JPEG_LIBRARIES})
        list(APPEND IMAGE_DEFINES ${JPEG_DEFINITIONS})
        list(APPEND IMAGE_INCLUDE_DIRECTORIES ${JPEG_INCLUDE_DIR})
        include_directories(SYSTEM ${JPEG_INCLUDE_DIR})
    else()
        if(MINGW AND JPEG_FOUND AND NOT JPEG_COMPILES)
            message("WARNING: libjpeg found but the headers appear to "
                "conflict with your MinGW headers, so disabling support. "
                "Try a later version.")
        else()
            message("WARNING: libjpeg not found, disabling support")
        endif()
    endif()
endif(WANT_IMAGE_JPG AND NOT ALLEGRO_CFG_IIO_SUPPORT_JPG)

configure_file(
    allegro5/internal/aintern_image_cfg.h.cmake
    ${PROJECT_BINARY_DIR}/include/allegro5/internal/aintern_image_cfg.h
    )

add_our_addon_library(allegro_image
    AllegroImage-${ALLEGRO_SOVERSION}
    "${IMAGE_SOURCES};${IMAGE_INCLUDE_FILES}"
    "-DALLEGRO_IIO_SRC"
    "${ALLEGRO_LINK_WITH};${IMAGE_LIBRARIES}"
    )

install_our_headers(${IMAGE_INCLUDE_FILES})

add_addon(image)

#-----------------------------------------------------------------------------#
# vi: set ts=8 sts=4 sw=4 et:

=== addons/ttf/CMakeLists.txt ===
include_directories(../font)
include_directories(SYSTEM ${FREETYPE_INCLUDE_DIRS})

set(TTF_SOURCES ttf.c)

set(TTF_INCLUDE_FILES allegro5/allegro_ttf.h)

set_our_header_properties(${TTF_INCLUDE_FILES})

configure_file(
    allegro5/internal/aintern_ttf_cfg.h.cmake
    ${PROJECT_BINARY_DIR}/include/allegro5/internal/aintern_ttf_cfg.h
    )

set(TTF_LIBRARIES ${FREETYPE_LIBRARIES})
set(TTF_INCLUDE_DIRECTORIES ${FREETYPE_INCLUDE_DIRS})

# FREETYPE_LIBRARIES should include zlib automatically if statically linking,
# but it doesn't.
find_package(ZLIB)
if(ZLIB_FOUND AND NOT IPHONE)
    list(APPEND TTF_LIBRARIES ${ZLIB_LIBRARIES})
endif()

add_our_addon_library(allegro_ttf
    AllegroTTF-${ALLEGRO_SOVERSION}
    "${TTF_SOURCES};${TTF_INCLUDE_FILES}"
    "-DALLEGRO_TTF_SRC"
    "${FONT_LINK_WITH};${TTF_LIBRARIES}"
    )

install_our_headers(${TTF_INCLUDE_FILES})

add_addon(ttf)

#-----------------------------------------------------------------------------#
# vi: set ts=8 sts=4 sw=4 et:

=== demos/cosmic_protector/CMakeLists.txt ===
if(SUPPORT_FONT AND SUPPORT_AUDIO AND SUPPORT_ACODEC)
else()
    message(STATUS "Not building Cosmic Protector")
    return()
endif()

include_directories(
    include
    ${PROJECT_SOURCE_DIR}/addons/main
    ${PROJECT_SOURCE_DIR}/addons/image
    ${PROJECT_SOURCE_DIR}/addons/font
    ${PROJECT_SOURCE_DIR}/addons/audio
    ${PROJECT_SOURCE_DIR}/addons/acodec
    ${PROJECT_SOURCE_DIR}/addons/primitives
    )

set(DEMO_SRCS
    src/Asteroid.cpp
    src/BitmapResource.cpp
    src/Bullet.cpp
    src/ButtonWidget.cpp
    src/Debug.cpp
    src/DisplayResource.cpp
    src/Entity.cpp
    src/Explosion.cpp
    src/FontResource.cpp
    src/Game.cpp
    src/GUI.cpp
    src/Input.cpp
    src/LargeAsteroid.cpp
    src/LargeBullet.cpp
    src/LargeSlowBullet.cpp
    src/MediumAsteroid.cpp
    src/Player.cpp
    src/PowerUp.cpp
    src/Resource.cpp
    src/ResourceManager.cpp
    src/SampleResource.cpp
    src/StreamResource.cpp
    src/SmallAsteroid.cpp
    src/SmallBullet.cpp
    src/UFO.cpp
    src/cosmic_protector.cpp
    src/collision.cpp
    src/joypad_dummy.cpp
    src/logic.cpp
    src/render.cpp
    src/sound.cpp
    src/wave.cpp
    )

if(IPHONE)
    list(APPEND DEMO_SRCS src/cosmic_protector_objc.m)
endif(IPHONE)

set_source_files_properties(${DEMO_SRCS} PROPERTIES LANGUAGE "CXX")

file(GLOB_RECURSE DEMO_GFX RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}"
    data/gfx/*.png data/gfx/*.jpg data/gfx/*.tga)
file(GLOB_RECURSE DEMO_SFX RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}"
    data/sfx/*.ogg)
set(DEMO_ICON data/gfx/Icon.icns)

if(ANDROID)
    add_copy_commands(
        "${CMAKE_CURRENT_SOURCE_DIR}"
        "${CMAKE_CURRENT_BINARY_DIR}/cosmic_protector.project/assets"
        ASSETS
        "${DEMO_GFX}"
        "${DEMO_SFX}"
        )
    add_android_app(cosmic_protector
        "${DEMO_SRCS};${ASSETS}"
        "${ALLEGRO_LINK_WITH};${IMAGE_LINK_WITH};${FONT_LINK_WITH};${AUDIO_LINK_WITH};${ACODEC_LINK_WITH};${PRIMITIVES_LINK_WITH}"
        "stlport_shared"
        )
    return()
endif(ANDROID)

if(APPLE)
    set(DEMO_EXECUTABLE_TYPE MACOSX_BUNDLE)
else(APPLE)
    set(DEMO_EXECUTABLE_TYPE "${EXECUTABLE_TYPE}")
endif(APPLE)

add_executable(cosmic_protector
    ${DEMO_EXECUTABLE_TYPE}
    ${DEMO_SRCS}
    ${DEMO_GFX}
    ${DEMO_SFX}
    ${DEMO_ICON}
    )

fix_executable(cosmic_protector)

if(WANT_MONOLITH)
   target_link_libraries(cosmic_protector
       ${ALLEGRO_MONOLITH_LINK_WITH}
       )
else(WANT_MONOLITH)
   target_link_libraries(cosmic_protector
       ${ALLEGRO_MAIN_LINK_WITH}
       ${FONT_LINK_WITH}
       ${IMAGE_LINK_WITH}
       ${AUDIO_LINK_WITH}
       ${ACODEC_LINK_WITH}
       ${PRIMITIVES_LINK_WITH}
       )
endif(WANT_MONOLITH)

if(NOT BUILD_SHARED_LIBS)
    set_target_properties(cosmic_protector PROPERTIES COMPILE_FLAGS "-DALLEGRO_STATICLINK")
endif(NOT BUILD_SHARED_LIBS)

# Mac OS X bundle support.
set_target_properties(cosmic_protector PROPERTIES
    MACOSX_BUNDLE_COPYRIGHT "Copyright 2008 Allegro Developers"
    MACOSX_BUNDLE_ICON_FILE "Icon.icns"
    MACOSX_BUNDLE_INFO_STRING "5.0, Copyright 2008 Allegro Developers"
    MACOSX_BUNDLE_SHORT_VERSION_STRING "5.0"
    MACOSX_BUNDLE_LONG_VERSION_STRING "Cosmic Protector v5.0"
    MACOSX_BUNDLE_GUI_IDENTIFIER "org.liballeg.CosmicProtector"
    )
set_source_files_properties(${DEMO_GFX} PROPERTIES
    MACOSX_PACKAGE_LOCATION "Resources/data/gfx"
    )
set_source_files_properties(${DEMO_SFX} PROPERTIES
    MACOSX_PACKAGE_LOCATION "Resources/data/sfx"
    )
set_source_files_properties(${DEMO_ICON} PROPERTIES
    MACOSX_PACKAGE_LOCATION "Resources"
    )

copy_data_dir_to_build(copy_demo_data
    "${CMAKE_CURRENT_SOURCE_DIR}/data"
    "${CMAKE_CURRENT_BINARY_DIR}/data"
    )

add_dependencies(cosmic_protector copy_demo_data)

#-----------------------------------------------------------------------------#
# vi: set ts=8 sts=4 sw=4 et:

=== demos/skater/CMakeLists.txt ===
if(SUPPORT_FONT AND SUPPORT_AUDIO AND SUPPORT_ACODEC)
else()
    message(STATUS "Not building skater demo")
    return()
endif()

include_directories(
   ${PROJECT_SOURCE_DIR}/addons/acodec
   ${PROJECT_SOURCE_DIR}/addons/audio
   ${PROJECT_SOURCE_DIR}/addons/font
   ${PROJECT_SOURCE_DIR}/addons/image
   ${PROJECT_SOURCE_DIR}/addons/main
   ${PROJECT_SOURCE_DIR}/addons/primitives
   )

set(DEMO_SRCS
   src/anim.c
   src/background_scroller.c
   src/credits.c
   src/fps.c
   src/framework.c
   src/game.c
   src/gamepad.c
   src/global.c
   src/intro.c
   src/keyboard.c
   src/level_alloc.c
   src/level.c
   src/level_file.c
   src/level_state.c
   src/menu_about.c
   src/menu.c
   src/menu_controls.c
   src/menu_graphics.c
   src/menu_main.c
   src/menu_misc.c
   src/menu_options.c
   src/menu_sound.c
   src/menu_success.c
   src/mouse.c
   src/music.c
   src/physics.c
   src/quadtree.c
   src/screenshot.c
   src/skater.c
   src/token.c
   src/transition.c
   src/vcontroller.c
   )

file(GLOB SKATER_GRAPHICS data/graphics/*.png)
file(GLOB SKATER_AUDIO data/audio/*)
file(GLOB SKATER_MENU data/menu/*)
file(GLOB SKATER_LEVEL data/*.txt)

set(SKATER_DATA
    ${SKATER_GRAPHICS}
    ${SKATER_AUDIO}
    ${SKATER_MENU}
    ${SKATER_LEVEL}
    ${SKATER_FONTS}
    )

set(SKATER_REL_DATA)
foreach(data ${SKATER_DATA})
    file(RELATIVE_PATH relpath "${CMAKE_CURRENT_SOURCE_DIR}" "${data}")
    list(APPEND SKATER_REL_DATA "${relpath}")
endforeach(data)

if(ANDROID)
    add_copy_commands(
        "${CMAKE_CURRENT_SOURCE_DIR}"
        "${CMAKE_CURRENT_BINARY_DIR}/skater.project/assets"
        ASSETS
        "${SKATER_REL_DATA}"
        )
    add_android_app(skater
        "${DEMO_SRCS};${ASSETS}"
        "${ALLEGRO_LINK_WITH};${AUDIO_LINK_WITH};${ACODEC_LINK_WITH};${FONT_LINK_WITH};${IMAGE_LINK_WITH};${PRIMITIVES_LINK_WITH}"
        ""
        )
    return()
endif()

if(APPLE)
    set(DEMO_EXECUTABLE_TYPE MACOSX_BUNDLE)
else(APPLE)
    set(DEMO_EXECUTABLE_TYPE "${EXECUTABLE_TYPE}")
endif(APPLE)

add_executable(skater
    ${DEMO_EXECUTABLE_TYPE}
    ${DEMO_SRCS}
    ${SKATER_DATA}
    )

fix_executable(skater)

if(WANT_MONOLITH)
   target_link_libraries(skater
     ${ALLEGRO_MONOLITH_LINK_WITH}
     )
else(WANT_MONOLITH)
   target_link_libraries(skater
     ${ACODEC_LINK_WITH}
     ${AUDIO_LINK_WITH}
     ${FONT_LINK_WITH}
     ${IMAGE_LINK_WITH}
     ${ALLEGRO_MAIN_LINK_WITH}
     ${PRIMITIVES_LINK_WITH}
     )
endif(WANT_MONOLITH)

if(NOT BUILD_SHARED_LIBS)
    set_target_properties(skater PROPERTIES COMPILE_FLAGS "-DALLEGRO_STATICLINK")
endif(NOT BUILD_SHARED_LIBS)

# Mac OS X bundle support.
set_target_properties(skater PROPERTIES
    MACOSX_BUNDLE_COPYRIGHT "Copyright 2010 Allegro Developers"
    #MACOSX_BUNDLE_ICON_FILE "Icon.icns"
    MACOSX_BUNDLE_INFO_STRING "5.1, Copyright 2010 Allegro Developers"
    MACOSX_BUNDLE_SHORT_VERSION_STRING "5.1"
    MACOSX_BUNDLE_LONG_VERSION_STRING "Allegro Skater Demo v5.1"
    MACOSX_BUNDLE_GUI_IDENTIFIER "org.liballeg.skater"
    )

set_source_files_properties(${SKATER_GRAPHICS} PROPERTIES
    MACOSX_PACKAGE_LOCATION "Resources/data/graphics"
    )
set_source_files_properties(${SKATER_AUDIO} PROPERTIES
    MACOSX_PACKAGE_LOCATION "Resources/data/audio"
    )
set_source_files_properties(${SKATER_MENU} PROPERTIES
    MACOSX_PACKAGE_LOCATION "Resources/data/menu"
    )
set_source_files_properties(${SKATER_LEVEL} PROPERTIES
    MACOSX_PACKAGE_LOCATION "Resources/data"
    )

copy_data_dir_to_build(copy_skater_data
    "${CMAKE_CURRENT_SOURCE_DIR}/data"
    "${CMAKE_CURRENT_BINARY_DIR}/data"
    )

add_dependencies(skater copy_skater_data copy_example_data)

#-----------------------------------------------------------------------------#
# vi: set ts=8 sts=4 sw=4 et:

=== demos/speed/CMakeLists.txt ===
# Prefer local headers to system directories.
include_directories(
    ${PROJECT_SOURCE_DIR}/addons/main
    ${PROJECT_SOURCE_DIR}/addons/audio
    ${PROJECT_SOURCE_DIR}/addons/font
    ${PROJECT_SOURCE_DIR}/addons/primitives
    )

set(SPEED_SRCS
    a4_aux.c
    badguys.c
    bullets.c
    explode.c
    hiscore.c
    main.c
    message.c
    player.c
    sound.c
    title.c
    view.c
    )

if(NOT SUPPORT_AUDIO OR NOT SUPPORT_PRIMITIVES OR NOT SUPPORT_FONT)
    message(STATUS "Not building SPEED")
    return()
endif()

if(COMPILER_GCC_OR_CLANG)
    set(CMAKE_C_FLAGS
        "${CMAKE_C_FLAGS} -Wno-strict-prototypes -Wno-missing-prototypes")
endif(COMPILER_GCC_OR_CLANG)

if(ANDROID)
    add_android_app(speed
        "${SPEED_SRCS}"
        "${ALLEGRO_LINK_WITH};${AUDIO_LINK_WITH};${PRIMITIVES_LINK_WITH};${FONT_LINK_WITH}"
        ""
        )
    return()
endif(ANDROID)

if(APPLE)
    set(DEMO_EXECUTABLE_TYPE MACOSX_BUNDLE)
else(APPLE)
    set(DEMO_EXECUTABLE_TYPE "${EXECUTABLE_TYPE}")
endif(APPLE)

add_executable(speed ${DEMO_EXECUTABLE_TYPE} ${SPEED_SRCS})

fix_executable(speed)

if(WANT_MONOLITH)
   target_link_libraries(speed
       ${ALLEGRO_MONOLITH_LINK_WITH}
       )
else(WANT_MONOLITH)
   target_link_libraries(speed
       ${ALLEGRO_MAIN_LINK_WITH}
       ${AUDIO_LINK_WITH}
       ${PRIMITIVES_LINK_WITH}
       ${FONT_LINK_WITH}
       )
endif(WANT_MONOLITH)

if(NOT BUILD_SHARED_LIBS)
    set_target_properties(speed PROPERTIES COMPILE_FLAGS "-DALLEGRO_STATICLINK")
endif(NOT BUILD_SHARED_LIBS)

#-----------------------------------------------------------------------------#
# vim: set ts=8 sts=4 sw=4 et:

=== debian/changelog ===
allegro5 (2:5.2.2-1) unstable; urgency=medium

  [ Tobias Hansen ]
  * New upstream release.
  * Remove fix-fallback-path-max.patch, applied upstream.
  * New Build-Depends: libenet-dev, libopus-dev, libopusfile-dev.
  * Update symbols files with new symbols.
  * Generate *.install files for addons from templates.
  * Link with enet in compile_examples.sh.
  * Use https urls for Vcs-* fields.

  [ Andreas Rönnquist ]
  * Add hardening flags to build.
  * Remove unused lintian overrides.

 -- Tobias Hansen <thansen@debian.org>  Mon, 02 Jan 2017 15:51:27 +0100

=== debian/control ===
Source: allegro5
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Tobias Hansen <thansen@debian.org>, Andreas Rönnquist <gusnan@debian.org>
Build-Depends: debhelper (>= 9),
               cmake,
               libdumb1-dev,
               libenet-dev,
               libflac-dev,
               libfreetype6-dev,
               libgl1-mesa-dev,
               libglu1-mesa-dev,
               libgtk2.0-dev,
               libjpeg-dev,
               libopenal-dev,
               libopus-dev,
               libopusfile-dev,
               libphysfs-dev,
               libpng-dev,
               libpulse-dev,
               libtheora-dev,
               libvorbis-dev,
               libxext-dev,
               libxxf86vm-dev,
               libxrandr-dev,
               libxinerama-dev,
               libxpm-dev,
               ttf-dejavu-core,
               python,
               indent
Build-Depends-Indep: pandoc, pandoc-data (>= 1.11.1-4) | pandoc (<< 1.11.1-4)
Standards-Version: 3.9.8
Section: libs
Homepage: http://liballeg.org/
Vcs-Git: https://anonscm.debian.org/git/pkg-games/allegro5.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/allegro5.git

Package: liballegro5.2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: portable library for cross-platform game and multimedia development
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro5-dev
Priority: extra
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         liballegro5.2 (= ${binary:Version}),
         libc-dev,
         libgl1-mesa-dev,
         libglu1-mesa-dev,
         libice-dev,
         libsm-dev,
         libx11-dev,
         libxcursor-dev,
         libxext-dev,
         libxinerama-dev,
         libxpm-dev,
         libxrandr-dev
Recommends: liballegro-acodec5-dev,
            liballegro-audio5-dev,
            liballegro-dialog5-dev,
            liballegro-image5-dev,
            liballegro-physfs5-dev,
            liballegro-ttf5-dev,
            liballegro-video5-dev
Suggests: allegro5-doc
Description: development files for the Allegro 5 library
 This package is needed to build programs using the Allegro 5 library.
 Contains header files.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro-acodec5.2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         liballegro5.2 (= ${binary:Version})
Description: audio codec addon for the Allegro 5 library
 This package provides the audio codec addon for the Allegro 5 library.
 This addon allows you to load audio sample formats.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro-acodec5-dev
Priority: extra
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         liballegro-acodec5.2 (= ${binary:Version}),
         liballegro5-dev (= ${binary:Version}),
         libopenal-dev,
         libopus-dev,
         libpulse-dev,
         libdumb1-dev,
         libflac-dev,
         libvorbis-dev
Description: header files for the Allegro 5 audio codec addon
 This package is required to build programs that use the Allegro 5 audio
 codec addon.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro-audio5.2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
         liballegro5.2 (= ${binary:Version})
Description: audio addon for the Allegro 5 library
 This package provides the audio addon for the Allegro 5 library. This
 addon allows you to play sounds in your Allegro 5 programs.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro-audio5-dev
Priority: extra
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         liballegro-audio5.2 (= ${binary:Version}),
         liballegro5-dev (= ${binary:Version}),
         libopenal-dev,
         libpulse-dev 
Description: header files for the Allegro 5 audio addon
 This package is required to build programs that use the Allegro 5 audio
 addon.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro-dialog5.2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
         liballegro5.2 (= ${binary:Version})
Description: dialog addon for the Allegro 5 library
 This package provides the dialog addon for the Allegro 5 library. This
 addon allows you to show dialog boxes.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro-dialog5-dev
Priority: extra
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         liballegro-dialog5.2 (= ${binary:Version}),
         liballegro5-dev (= ${binary:Version}),
         libgtk2.0-dev
Description: header files for the Allegro 5 dialog addon
 This package is required to build programs that use the Allegro 5 dialog
 addon.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro-image5.2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
         liballegro5.2 (= ${binary:Version})
Description: image addon for the Allegro 5 library
 This package provides the image addon for the Allegro 5 library. Provides
 support for loading image file formats.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro-image5-dev
Priority: extra
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         liballegro-image5.2 (= ${binary:Version}),
         liballegro5-dev (= ${binary:Version}),
         libjpeg-dev,
         libpng-dev
Description: header files for the Allegro 5 image addon
 This package is required to build programs that use the Allegro 5 image
 addon.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro-physfs5.2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
         liballegro5.2 (= ${binary:Version})
Description: physfs addon for the Allegro 5 library
 This package provides the physfs addon for the Allegro 5 library. This
 addon provides an interface to the PhysicsFS library, allowing you to
 mount virtual file-systems (e.g., archives) and access files as if they
 were physically on the file-system.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro-physfs5-dev
Priority: extra
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         liballegro-physfs5.2 (= ${binary:Version}),
         liballegro5-dev (= ${binary:Version}),
         libphysfs-dev
Description: header files for the Allegro 5 physfs addon
 This package is required to build programs that use the Allegro 5 physfs
 addon.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro-ttf5.2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
         liballegro5.2 (= ${binary:Version})
Description: ttf addon for the Allegro 5 library
 This package provides the ttf addon for the Allegro 5 library. This addon
 allows you to load and use ttf fonts in your Allegro 5 programs.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Use this variable to allow options passed to cmake to be overridable.
# WANT_EXAMPLES is set to ON only to check if they build successfully,
# as their source is shipped in the doc package.
DEB_CMAKE_OPTIONS ?= -DCMAKE_VERBOSE_MAKEFILE=ON \
		-DCMAKE_INSTALL_PREFIX="/usr" \
		-DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
                -DWANT_DEMO=OFF \
                -DWANT_EXAMPLES=ON \
                -DWANT_DOCS=ON \
                -DWANT_DOCS_HTML=ON \
                -DWANT_DOCS_MAN=ON

ADDONS = acodec audio image physfs ttf video
ADDONS_INSTALL = $(ADDONS:%=debian/liballegro-%5.2.install)
ADDONS_DEV_INSTALL = $(ADDONS:%=debian/liballegro-%5-dev.install)

debian/liballegro-%5.2.install: debian/liballegro-ADDON5.2.install.in debian/rules
	sed -e 's/ADDON/$*/g' < "$<" > "$@"

debian/liballegro-%5-dev.install: debian/liballegro-ADDON5-dev.install.in debian/rules
	sed -e 's/ADDON/$*/g' < "$<" > "$@"

%:
	dh $@ --builddirectory=build --parallel

override_dh_auto_configure:
# Delete possibly non-free images/music.
	rm -rf examples/data/haiku demos
# Delete precompiled files.
	rm -rf docs/man/ docs/html/
	rm examples/data/DejaVuSans.*
	rm addons/audio/kcm_mixer_helpers.inc
	rm include/allegro5/opengl/GLext/*gl*_ext_alias.h
	rm src/convert.c include/allegro5/internal/aintern_convert.h
	rm src/scanline_drawers.*
	rm addons/primitives/directx_shaders.cpp
# Regenerate generated files.
	misc/regenerate.sh
	dh_auto_configure -- $(DEB_CMAKE_OPTIONS)
# Remove the tests which only work with the display present.
# (See https://github.com/liballeg/allegro5/issues/626
# and https://github.com/liballeg/allegro5/issues/627)
	rm tests/test_compressed.ini
	rm tests/test_convert.ini

override_dh_clean:
	rm -f $(ADDONS_INSTALL) $(ADDONS_DEV_INSTALL)
	dh_clean

override_dh_auto_install: $(ADDONS_INSTALL) $(ADDONS_DEV_INSTALL)
	dh_auto_install
	mkdir -p debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/allegro5/platform
	mv debian/tmp/usr/include/allegro5/platform/alplatf.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/allegro5/platform/alplatf.h
	sed -i 's@Cflags: -I$${includedir}@Cflags: -I$${includedir}/$(DEB_HOST_MULTIARCH)@' debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/allegro-*.pc

override_dh_auto_test:
	cd build && tests/test_driver --no-display ../tests/test_*.ini

override_dh_installchangelogs:
	dh_installchangelogs CHANGES-5.2.txt

override_dh_installexamples-indep:
	dh_installexamples
# Delete haiku example, because we are not shipping its data.
	rm debian/allegro5-doc/usr/share/doc/allegro5-doc/examples/ex_haiku.c
# Fix permissions
	find debian/allegro5-doc/usr/share/doc/allegro5-doc/examples -type f -exec chmod 644 \{\} \+

=== debian/watch ===
version=3
http://download.gna.org/allegro/allegro/(\d+\.\d?[02468]\.\d+)/allegro-(\d+\.\d?[02468]\.\d+)\.tar\.gz
